> For the complete documentation index, see [llms.txt](https://docs.exoclick.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.exoclick.com/rtb/advertisers/exoclick-rtb/bid-response.md).

# ExoClick RTB Bid Response

The ExoClick RTB Bid Response can be done using JSON and XML. The response for a bid request should have the following structure:

## Bid Response Object

| Attribute   | Description                                                                                                                   |
| ----------- | ----------------------------------------------------------------------------------------------------------------------------- |
| id          | ID of the impression object to which this bid applies (string)                                                                |
| imgUrl      | Image url (only for type banner)                                                                                              |
| iconUrl     | Icon url (only for type push\_notification and must be of requested dimensions)                                               |
| clickUrl    | Forward url when campaign is clicked (for type banner or push\_notification)                                                  |
| url         | Forward url when campaign is clicked (only for type popunder)                                                                 |
| title       | Title of the ad (only for type push\_notification)                                                                            |
| description | Description of the ad (only for type push\_notification)                                                                      |
| value       | Bid price in CPM or CPC (float)                                                                                               |
| imptrackers | Impression trackers, optional (only for type push\_notification)                                                              |
| btype       | Pricing Model. Values: 1 = CPM, 2 = CPC. Default = 1 (int). When response is for an Email Clicks zone request, 1 = Smart CPC. |
| bUrl        | Billing notification URL, it is recommended to use HTTP over HTTPS for bUrl                                                   |

**Notes:**

* **"id"** attribute should match the **"id" received in the request**.
* **Push Notification** ad format may receive bids with the CPC pricing model. **Direct Link** format may also when used for **Email Click** zone requests.
* Also, when running Push Notification ads, only one **imptracker** URL is allowed.
* **bURL** is called when impression or click has been delivered, depending on CPM or CPC from btype field (default CPM)

## No Bid Response

To answer a bid request without making an actual bid, an HTTP response code 204 "No Content" should be sent.

## Add dynamic tokens to your endpoint

In addition to the information you receive through the request, you can also add **dynamic tokens** to your endpoint. This will allow you to quickly detect the origin of the request when reviewing the requests received.

Here you will find the most common tokens used ExoClick:

* **{site\_id}**: The ID number of the site where the ad is displayed.
* **{zone\_id}**: The ID of the ad zone where the ad is displayed.
* **{src\_hostname}**: The site name that the Publisher submitted for displaying ads, not including the HTTP protocol at the beginning (e.g. examplesite.com).
* **{url}**: The full URL of the site that the Publisher submitted to the Admin Panel for displaying ads, including the HTTP protocol (e.g. <https://examplesite.com>). Note: This token will not display the URL where the ad was displayed to the user; only the URL that is registered in our platform.
* **{tags}**: The list of keywords that have been identified for that ad impression.
* **{keyword}**: The keyword that was matched in case of campaigns targeting specific keywords. This will be empty if there is no match.
* **{language}**: The language of the visitor.
* **{\&empty=204}**: Add it to the endpoint whenever you return a No Bid response.
* **{imp\_id}**: Add it to receive the impression ID in the endpoint.

If you require other tokens or you need to track additional details, please contact your account manager.

## Examples

You can find detailed examples from Bid response in our [Advertiser Response example page](/rtb/advertisers/exoclick-rtb/exoclick-rtb-advertiser-code-examples.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.exoclick.com/rtb/advertisers/exoclick-rtb/bid-response.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
